#include <iostream>
#include <iomanip>
#include <map>
#include <cmath>
using namespace std;

typedef long double ld;

// be surprised if this managed to get need 10^5^2 lds here... 
static ld* cache;

int coins;
int flips;
int _nocache=0;
int _cached =0;
int _maxl = 0;

ld flip_count(int n, int k) {
	int idx = n + ((coins + 1) * k);
	//cout<<"n="<<n<<", k="<<k<<" (l="<<l<<"), idx="<<idx<<" ";
	//if (n>=k+0 or k>=n+400) return min(n-0.5L,k/2.L);
	if (k>=n+400) return min(n-0.5L,k/2.L);
	if (k == 0) {
		//cout<<endl;
		return 0; //(ld)(coins - n);
	}
    if (n == 0) {
    	//cout<<endl;
		return (ld)coins - 0.5;
	}

	// This speeds things up A LOT latest version from RGL.
	if (n == k) {
		return (ld)(coins - 0.5L*n);
	}
	if (cache[idx] == 0){
    	cache[idx] = 0.5L*(flip_count(n-1, k-1) + flip_count(n, k-1));
  	}
	return cache[idx];
};

int main(){
	cin>>coins;
	cin>>flips;

	cache = new ld[(coins + 1) * (flips + 1)]();
	ld result = (coins > flips) ? 0.5L*flips : flip_count(coins, flips);

  cout.precision(10);
	cout<<result<<'\n';
}
