#include <iostream>
#include <iomanip>
#include <map>
using namespace std;

typedef long double ld;

static map<pair<int,int>,ld> cache;

int coins;

ld flip_count(int n, int k) {
	if (k == 0) {
		return (ld)(coins - n);
	}
    if (n == 0) {
		return (ld)coins - 0.5;
	}

	// This speeds things up A LOT.	
	if (n == k) {
		return (ld)(coins - 0.5L*n);
	}

	if (cache.count({n,k}) == 0) {
    	cache[{n,k}] = flip_count(n-1, k-1)/2 + flip_count(n, k-1)/2;
  	}
	return cache[{n,k}];
};

int main(){
	cin>>coins;
	ld k; cin>>k;

	ld result = flip_count(coins, k);

  cout.precision(7);
	cout<<result<<'\n';
}
