#!/usr/bin/env python3
from itertools import accumulate
from math import factorial,log2

n,k = map(int, input().split())
facts = list(accumulate([log2(max(1,i)) for i in range(k+1)]))

res = 0
for i in range(1,k+1):
    val = n - int((i-n) % 2) if i >= n else i
    res += val * 2.0**(facts[k] - facts[i] - facts[k-i] - k)

print('%.10f' % res)
