#!/usr/bin/env python

def power_of_two(v):
  for i in range(1, 5):
    v = v & ~(v >> (1<<i))
  return v

def write_swap(a, b, rev):
  if min(a,b) < 0 or max(a,b) >= len(word): return
  if rev: a,b = b,a
  print word[a][1]+1, word[b][1]+1

def exprange(a,b):
  while a <= b:
    yield a
    a *= 2

def generate_bitonic_sort(b):
  for span in exprange(2,b*2):
    for shift in list(exprange(1,span/2))[::-1]:
      for i in range(b-shift):
        write_swap(i,i+shift,(i/span)%2)

word = raw_input()[::]
word = sorted(zip(word, range(len(word))))

generate_bitonic_sort(power_of_two(len(word)*2))
