import java.util.*;

public class rglrandom {
    private static final class XYZ {
        public int x, y, z;

        public static XYZ from(Scanner sc) {
            XYZ ret = new XYZ();
            ret.x = sc.nextInt();
            ret.y = sc.nextInt();
            ret.z = sc.nextInt();
            return ret;
        }

        public XYZ towards(XYZ o) {
            XYZ ret = new XYZ();
            ret.x = x;
            ret.y = y;
            ret.z = z;
            if (x != o.x) {ret.x += (o.x > x ? 1: -1); return ret;}
            if (y != o.y) {ret.y += (o.y > y ? 1: -1); return ret;}
            if (z != o.z) {ret.z += (o.z > z ? 1: -1); return ret;}
            return ret;
        }

        private static int rng1 = 0;
        private static int rng2 = 3;
        private static int rng3 = 15;

        public XYZ anyway() {
            XYZ ret = new XYZ();
            ret.x = x;
            ret.y = y;
            ret.z = z;

            int rng = (rng1 * 29 + rng2 * 5 + rng3 * 17) % (6 * 17);
            rng1 = rng2 % 5; rng2 = rng3; rng3 = rng % 17;
            rng %= 6;

            if (rng <= 2) {ret.x += (rng % 2) * 2 - 1; return ret;}
            if (rng <= 4) {ret.y += (rng % 2) * 2 - 1; return ret;}
            if (rng <= 6) {ret.z += (rng % 2) * 2 - 1; return ret;}
            return ret;
        }

        public boolean equals(XYZ o) {
            return x==o.x && y==o.y && z==o.z;
        }

        public String toString() {
            return "(" + x + " " + y + " " + z + ")";
        }
    }

    public static void main(String[] args) {
        final Scanner sc = new Scanner(System.in);

        XYZ a1 = XYZ.from(sc);
        XYZ a2 = XYZ.from(sc);
        XYZ b1 = XYZ.from(sc);
        XYZ b2 = XYZ.from(sc);

        System.out.println("" + a1 + " " + b1);
        while (!a1.equals(a2) || !b1.equals(b2)) {
            boolean firstTry = true;
            int iterations = 1;
            while (iterations > 0) {
                XYZ ap = (firstTry ? a1.towards(a2) : a1.anyway());
                XYZ bp = (firstTry ? b1.towards(b2) : b1.anyway());
                if (ap.equals(bp) || ap.equals(b1) && bp.equals(a1)) {
                    if (firstTry) {
                        firstTry = false;
                        iterations = 4;
                    }
                    continue;
                }
                a1 = ap;
                b1 = bp;
                iterations--;
                System.out.println("" + a1 + " " + b1);
            }
        }
    }
}
