#include <bits/stdc++.h>
using namespace std;
typedef long long ll;

struct Person{
  int min_dist;
  int max_dist;
  int pos;
};

bool good(int i,vector<Person> const &p,vector<ll> const &v){
  if (i-1>=0       and v[p[i].pos+1]-v[p[i-1].pos] > min(p[i].max_dist,p[i-1].max_dist)
   or i+1<p.size() and v[p[i+1].pos]-v[p[i].pos+1] < max(p[i].min_dist,p[i+1].min_dist) and p[i+1].pos!=v.size()-1)
    return false;
  return true;
}

int main(){
  ll max_distance; cin>>max_distance;

  int m; cin>>m;
  vector<ll> v(m); for (auto &i: v) cin>>i;

  int n; cin>>n;
  vector<Person> p(n); for (auto &i: p) cin>>i.min_dist>>i.pos, --i.pos, i.max_dist=max_distance;

  set<int> can_move,finished;
  for (int i=0; i<n; i++){
    can_move.insert(i);
  }

  vector<int> res;
  while (not can_move.empty()){
    auto ip=can_move.begin(); int const i=*ip; can_move.erase(ip);
    if (i<0 or i>=n or p[i].pos==m-1 or not good(i,p,v)){
      if (p[i].pos==m-1) finished.insert(i);
      continue;
    }
    ++p[i].pos;
    res.push_back(i+1);
    for (int x: {-1,0,+1}) can_move.insert(i+x);
  }

  if (finished.size()!=n){
    cout<<"impossible"<<endl;
    return 0;
  }

  for (int i=0; i<res.size(); i++){
    cout<<res[i]<<(i+1==res.size()?'\n':' ');
  }
}
