#include <bits/stdc++.h>
using namespace std;

int gcd(int a,int b){return b?gcd(b,a%b):a;}

struct vec2{
  int x,y;

  int length()const{
    int g=gcd(abs(x),abs(y));
    return g;
  }

  vec2 normalised()const{
    int g=max(length(),1);
    return {x/g,y/g};
  }

  bool operator<(vec2 const &a)const{
    return x!=a.x? x<a.x: y<a.y;
  }
};

int main(){
  vec2 tv; cin>>tv.x>>tv.y;
  map<vec2,vector<pair<int,int>>> angles;
  int n; cin>>n; while (n--){
    vec2 p; int h; cin>>p.x>>p.y>>h; p.x-=tv.x; p.y-=tv.y;
    angles[p.normalised()].emplace_back(p.length(),h);
  }

  int res=0;
  for (auto &item: angles){
    sort(item.second.begin(),item.second.end());
    vector<int> patience;
    for (auto const &i: item.second){
      int x=i.second;
      auto it=upper_bound(patience.begin(),patience.end(),x);
      if (it==patience.end()) patience.push_back(x); else *it=x;
    }
    res+=patience.size();
  }
  cout<<res<<endl;
}
