#include <list>
#include <stack>
#include <queue>
#include <set>
#include <map>
#include <algorithm>
#include <iostream>
#include <sstream>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <cstring>
#include <cfloat>
#include <climits>
#include <numeric>
#include <iomanip>

using namespace std;

const int oo = 0x3f3f3f3f;
const double eps = 1e-9;
const double PI = 2.0 * acos(0.0);


typedef long long ll;
typedef unsigned long long ull;
typedef pair<int, int> pii;
typedef vector<int> vi;
typedef vector<string> vs;

#define sz(c) int((c).size())
#define all(c) (c).begin(), (c).end()
#define FOR(i,a,b) for (int i = (a); i < (b); i++)
#define FORS(i,a,b,s) for (int i = (a); i < (b); i=i+(s))
#define FORD(i,a,b) for (int i = int(b)-1; i >= (a); i--)
#define FORIT(i,c) for (__typeof__((c).begin()) i = (c).begin(); i != (c).end(); i++)

struct dep{
	int n,c,p;
	bool u = false;

	bool operator<(dep const &d)const{ return p < d.p; }
};

dep d[100000];
int sol[100000];

int main(){
	int N,M; cin >> N >> M;
	vector<pii> s(N+2);
	FOR(i,0,N) cin >> s[i].first, s[i].second = i;
	s[N].first = -1;
	s[N+1].first = oo;
	FOR(i,0,M) d[i].n = i, cin >> d[i].c;
	FOR(i,0,M) cin >> d[i].p;

	sort(all(s));
	sort(d,d+M);

	FOR(i,0,M) if (sz(s)) {
		// binary search on s
		int hi = sz(s);
		int lo = 0;

		while (lo + 1 < hi){
			int mi = (hi + lo) / 2;
			if (s[mi].first <= d[i].c) lo = mi; else hi = mi;
		}

		if (lo == 0) continue;
		sol[s[lo].second] = d[i].n;
		s.erase(s.begin()+lo);
	}

	if (s.size()!=2) {
		cout << "impossible" << endl;
		return 0;
	}

	FOR(i,0,N){
		if (i) cout << " ";
		cout << sol[i] + 1;
	}

	cout << endl;
}
