#!/usr/bin/env pypy
import heapq
import sys

rl = sys.stdin.readline
(n, m) = map(int, rl().split())
demands = map(int, rl().split())
caps = map(int, rl().split())
costs = map(int, rl().split())
pool = list(sorted(zip(costs, caps, range(1, m+1)),
                   key = lambda x: -x[1]))
pcur = 0
avail = []
ans = [0]*n
for (demand, idx) in sorted(zip(demands, range(n)), reverse=True):
    while pcur < m and pool[pcur][1] >= demand:
        heapq.heappush(avail, pool[pcur])
        pcur += 1
    if len(avail) == 0:
        print 'impossible'
        sys.exit(0)
    ans[idx] = heapq.heappop(avail)[2]
print ' '.join(map(str, ans))



