#include <bits/stdc++.h>
using namespace std;
typedef long long ll;

map<int,ll> edge[2654321];
int pop[1654321];
int cap[1654321];
int rent[1654321];

vector<int> shortest_path(int s,int t){
  queue<int> q;
  static int f[212345];
  static int d[212345];
  static bool inq[212345];
  memset(f,-1,sizeof f);
  q.push(s); d[s]=0; inq[s]=true;
  while (not q.empty()){
    int z=q.front(); q.pop(); inq[z]=false;
    for (auto x: edge[z]){
      if (x.first and (f[x.first]==-1 or d[x.first]>d[z]+x.second)){
        d[x.first]=d[z]+x.second;
        f[x.first]=z;
        if (not inq[x.first]) {q.push(x.first); inq[x.first]=true;}
      }
    }
  }
  if (!~f[t]) return {};
  vector<int> res;
  for (int i=t; ~i; i=f[i]) res.push_back(i);
  reverse(res.begin(),res.end());
  return res;
}

int main(){
  int n,m; cin>>n>>m;

  for (int i=1; i<=n; i++) cin>>pop[i];
  for (int i=1; i<=m; i++) cin>>cap[i];
  for (int i=1; i<=m; i++) cin>>rent[i];

  for (int i=1; i<=n; i++)
    for (int j=1; j<=m; j++)
      if (pop[i]<=cap[j])
        edge[i][n+j]=0;

  for (int i=1; i<=n; i++) edge[0][i]=0;
  for (int i=1; i<=m; i++) edge[n+i][n+m+1]=rent[i];

  for (int i=1; i<=n; i++){
    vector<int> sp=shortest_path(0,n+m+1);
    if (not sp.size()) {cout<<"impossible\n";return 0;}
    for (int j=1; j<sp.size(); j++){
      edge[sp[j]][sp[j-1]]=-edge[sp[j-1]][sp[j]];
      edge[sp[j-1]].erase(sp[j]);
    }
  }

  vector<ll> res(n+1);
  for (int i=1; i<=m; i++)
    if (not edge[n+i].count(n+m+1))
      res[edge[n+i].begin()->first]=i;

  for (int i=1; i<=n; i++)
    cout<<res[i]<<(i- - -n?' ':'\n');
}
