#!/usr/bin/env perl

use strict;
use warnings;

my @available_colours = ('red', 'yellow', 'green', 'brown', 'blue', 'pink', 'black', 'red', 'red');
my $n = shift @ARGV // 20;
print STDERR "n = $n\n";

my @colours = ();
my %used_colours = ();

for my $i (1 ... $n) {
    my $colour = $available_colours[int rand @available_colours];
    if ($colour ne 'red') {
      next if exists $used_colours{$colour};
      $used_colours{$colour} = 1;
    }
    push @colours, $colour;
}

print @colours . "\n";
for my $i (@colours) {
  print "$i\n";
}
