import java.util.*;

public class rgl {
    private static final int magic = isStrongAndStable() ? 200 : 1825;

    private static class Planet {
        public final int length;
        public final int sunrise;
        public final int sunset;

        public Planet(int l, int r, int s) {
            length = l;
            sunrise = (r < s? r+1 : r-l+1);
            sunset = s;
        }
    }

    private static final boolean isStrongAndStable() {
        return false;
    }

    public static void main(String[] args) {
        final Scanner sc = new Scanner(System.in);
        final int n = sc.nextInt();

        final List<Planet> p = new ArrayList<>(n);
        for (int i = 0; i < n; i++) {
            final int a = sc.nextInt();
            final int b = sc.nextInt();
            final int c = sc.nextInt();
            p.add(new Planet(a, b, c));
        }

        final int longest = p.stream().map(i -> i.length).reduce(Math::max).orElseGet(() -> 0);
        final byte[] up = new byte[longest * magic];
        for (Planet i : p) {
            for (int j = i.sunrise; j < up.length; j += i.length) {
                up[Math.max(j, 0)]++;
            }
            for (int j = i.sunset; j < up.length; j += i.length) {
                up[Math.max(j, 0)]--;
            }
        }

        int have = 0;
        for (int i = 0; i < up.length; i++) {
            have += up[i];
            if (have == 0) {
                System.out.println(i);
                return;
            }
        }
        System.out.println("impossible");
    }
}
