#!/usr/bin/env perl

use strict;
use warnings;

my $bounds = 1000;

my $n = pop @ARGV || 4;
my $w = 1 + rand($bounds - 1);
print STDERR "Generating $n-sided shape with edge width=$w slice=$s\n";

my $tau = 3.141592*2;
my $angle = rand($tau);
my $ox = rand($bounds*2) - $bounds;
my $oy = rand($bounds*2) - $bounds;

print "$n\n";
for my $i (1 .. $n) {
    my $x = $ox + $w * cos($i/$n*$tau + $angle);
    my $y = $oy + $w * sin($i/$n*$tau + $angle);
    print "$x $y\n";
}
