#!/usr/bin/env python
from sys import exit

n = int(raw_input())
v = map(lambda i: map(int, raw_input().split()), range(n))

assert 3 <= n <= 100, 'Number of vertices is out of bounds'

area = 0
for i,j in zip(v, v[1:] + v[:1]):
  area += (j[1]-v[0][1]) * (i[0]-v[0][0]) \
        - (j[0]-v[0][0]) * (i[1]-v[0][1])

if area >= 0:
  exit(42)
else:
  print 'Polygon is not clockwise'
  exit(1)
