#include <bits/stdc++.h>
using namespace std;
typedef long double ld;

vector<ld> factorial;
map<pair<int,int>,ld> memo;

ld solve(int const n,int const k){
  if (n>=k+0 or k>=n+400) return min(n-0.5L,k/2.L);
  if (k==0) return 0;
  if (n<=1) return n-0.5L;
  if (memo.count({n,k})) return memo[{n,k}];

  ld res=0.L;
  int batch=n;
  for (int x: {5000,500,50,5})
    if (batch>=x*2)
      {batch=x+(k%x); break;}

  for (int i=0; i<=batch; i++){
    ld const prob=exp2l(factorial[batch]-factorial[i]-factorial[batch-i]-batch);
    res+=prob*(i+solve(n-i,k-batch));
  }
  return memo[{n,k}]=res;
}

int main(){
  int n,k; cin>>n>>k;
  ld res=0.L;
  ld ways=0;

  factorial.resize(k+1);
  for (int i=1; i<=k; i++){
    factorial[i]=factorial[i-1]+log2l(i);
  }
  cout.precision(16);
  cout<<solve(n,k)<<endl;
}
