#!/usr/bin/env python
from sys import exit

max_sep = int(raw_input())

raw_input()
v = map(int, raw_input().split())
people = map(lambda p: [p[0], p[1]-1], map(lambda i: map(int, raw_input().split()), range(int(raw_input()))))

def can_move(i):
  global people
  if i < 0 or i >= len(people) or people[i][1] == len(v)-1:
    return False
  if i > 0 and v[people[i][1]+1] - v[people[i-1][1]] > max_sep:
    return False
  if i+1 < len(people) \
      and people[i+1][1] <> len(v) - 1 \
      and v[people[i+1][1]] - v[people[i][1]+1] < max(people[i][0], people[i+1][0]):
    return False
  return True

finished = set()
good = set()
for i in range(len(people)):
  if can_move(i):
    good.add(i)

moves = []
while len(good) > 0:
  x = good.pop()
  moves += [x+1]
  people[x][1] += 1
  if people[x][1] == len(v)-1:
    finished.add(x)
  if x-1 in good: good.remove(x-1)
  if x+1 in good: good.remove(x+1)
  if can_move(x-1): good.add(x-1)
  if can_move(x):   good.add(x)
  if can_move(x+1): good.add(x+1)

if len(finished) < len(people):
  print 'impossible'
else:
  print ' '.join(map(str, moves))
