#include <algorithm>
#include <iostream>
#include <cassert>
#include <utility>
#include <vector>
#include <tuple>
#include <set>
using namespace std;
typedef tuple<int,int,int> tp;

int main(){
  int n,m; cin>>n>>m;
  vector<int> res(n);

  set<pair<int,int>> pop;
  for (int i=0,x; i<n; i++) cin>>x, pop.insert({-x,i});

  vector<tp> v(m);
  for (int i=0; i<m; i++) get<2>(v[i])=i;
  for (auto &i: v) cin>>get<1>(i);
  for (auto &i: v) cin>>get<0>(i);
  sort(v.begin(),v.end());

  for (auto &i: v){
    auto it=pop.lower_bound({-get<1>(i),0});
    if (it!=pop.end()){
      res[it->second]=get<2>(i)+1;
      pop.erase(it);
    }
  }
  if (not pop.empty()){
    cout<<"impossible"<<endl;
  }
  else for (int i=0; i<n; i++){
    assert(0<res[i] and res[i]<=m);
    cout<<res[i]<<(i+1==n?'\n':' ');
  }
}
