#include <bits/stdc++.h>
using namespace std;
typedef long long ll;

int pop[112345];
int cap[112345];
int rent[112345];
int n,m;

int find_best_match(int x){
  int res=-1;
  for (int y=0; y<m; y++)
    if (pop[x]<=cap[y] and (res==-1 or rent[y]<=rent[res]))
      res=y;
  return res;
}

pair<int,int> find_best_pair(){
  vector<pair<int,int>> options;
  for (int i=0; i<n; i++)
    if (~pop[i]){
      int p=find_best_match(i);
      if (~p) options.emplace_back(i,p);
    }
  if (options.empty()) return {-1,-1};
  int best=0;
  for (int i=1; i<options.size(); i++)
    if (pop[options[i].first]>pop[options[best].first])
      best=i;
  return options[best];
}

int main(){
  cin>>n>>m;

  for (int i=0; i<n; i++) cin>>pop[i];
  for (int i=0; i<m; i++) cin>>cap[i];
  for (int i=0; i<m; i++) cin>>rent[i];

  vector<int> res(n);
  for (int i=1; i<=n; i++){
    auto p=find_best_pair();
    if (p.first==-1) {cout<<"impossible\n";return 0;}
    res[p.first]=p.second+1;
    pop[p.first]=-1;
    cap[p.second]=-1;
  }

  for (int i=0; i<n; i++)
    cout<<res[i]<<(i+1==n?'\n':' ');
}
