#!/usr/bin/env perl

use strict;
use warnings;

my $n = int (shift @ARGV // (1 + int rand 20));
my $strategy = (shift @ARGV // 'uniform');
print "$n\n";

if ($strategy eq 'uniform') {
    for my $i (1 ... $n) {
        my $h = 2 + int rand 99;
        my ($e, $b) = (0, 0);
        while ($e == $b) {
            $b = int rand $h;
            $e = int rand $h;
        }
        print "$h $b $e\n";
    }
} else {
    die "unknown strategy: $strategy";
}
